<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="单位名称" prop="unitName">
        <el-input v-model="queryParams.unitName" placeholder="请输入单位名称" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['sins:sawfcredsapr:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['sins:sawfcredsapr:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['sins:sawfcredsapr:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns" />
    </el-row>

    <el-table v-loading="loading" :data="dataList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="统一社会信用代码" align="center" prop="unitSocCreCode" v-if="columns.unitSocCreCode.visible" />
      <el-table-column label="单位名称" align="center" prop="unitName" v-if="columns.unitName.visible" />
      <el-table-column label="黑名单原因" align="center" prop="blackListReas" v-if="columns.blackListReas.visible" />
      <el-table-column label="黑名单开始日期" align="center" prop="blackListStartDate" v-if="columns.blackListStartDate.visible" width="180" />
      <el-table-column label="黑名单结束日期" align="center" prop="blackListEndDate" v-if="columns.blackListEndDate.visible" width="180" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['sins:sawfcredsapr:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['sins:sawfcredsapr:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <el-dialog :title="title" v-model="open" width="700px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules" label-width="100px">
        <el-row>
          <el-col :span="12">
            <el-form-item label="统一社会信用代码" prop="unitSocCreCode">
              <el-input v-model="form.unitSocCreCode" placeholder="请输入统一社会信用代码" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="单位名称" prop="unitName">
              <el-input v-model="form.unitName" placeholder="请输入单位名称" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="机构GUID" prop="orgGuid">
              <el-input v-model="form.orgGuid" placeholder="请输入机构GUID" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="黑名单相关元素" prop="blackListReleWiun">
              <el-input v-model="form.blackListReleWiun" placeholder="请输入黑名单相关元素" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="黑名单开始日期" prop="blackListStartDate">
              <el-date-picker v-model="form.blackListStartDate" type="datetime" placeholder="请选择黑名单开始日期" value-format="YYYY-MM-DD HH:mm:ss" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="黑名单结束日期" prop="blackListEndDate">
              <el-date-picker v-model="form.blackListEndDate" type="datetime" placeholder="请选择黑名单结束日期" value-format="YYYY-MM-DD HH:mm:ss" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="黑名单原因" prop="blackListReas">
              <el-input v-model="form.blackListReas" type="textarea" placeholder="请输入黑名单原因" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="备注" prop="note">
              <el-input v-model="form.note" type="textarea" placeholder="请输入备注" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup>
import { listSawfCredSapr, getSawfCredSapr, addSawfCredSapr, updateSawfCredSapr, delSawfCredSapr } from "@/api/slaj/sins";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();

const dataList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const columns = ref({
  unitSocCreCode: { visible: true },
  unitName: { visible: true },
  blackListReas: { visible: true },
  blackListStartDate: { visible: true },
  blackListEndDate: { visible: true },
});

const data = reactive({
  form: {},
  queryParams: { pageNum: 1, pageSize: 10, unitName: null },
  rules: {},
});
const { form, queryParams, rules } = toRefs(data);

function getList() {
  loading.value = true;
  listSawfCredSapr(queryParams.value).then(r => {
    dataList.value = r.rows;
    total.value = r.total;
    loading.value = false;
  });
}

function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

function handleSelectionChange(s) {
  ids.value = s.map(i => i.guid);
  single.value = s.length !== 1;
  multiple.value = !s.length;
}

function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加SAWF信用安全评估";
}

function handleUpdate(row) {
  reset();
  getSawfCredSapr(row.guid || ids.value[0]).then(r => {
    form.value = r.data;
    open.value = true;
    title.value = "修改SAWF信用安全评估";
  });
}

function submitForm() {
  proxy.$refs["formRef"].validate(v => {
    if (v) {
      if (form.value.guid != null) {
        updateSawfCredSapr(form.value).then(() => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addSawfCredSapr(form.value).then(() => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

function handleDelete(row) {
  proxy.$modal.confirm('确认删除？').then(function() {
    return delSawfCredSapr(row.guid || ids.value.join(","));
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  });
}

function handleExport() {
  proxy.download('/sins/sawfcredsapr/export', { ...queryParams.value }, `SAWF信用安全评估_${new Date().getTime()}.xlsx`);
}

function cancel() {
  open.value = false;
  reset();
}

function reset() {
  form.value = { guid: null, unitSocCreCode: null, unitName: null, blackListReas: null, blackListStartDate: null, blackListEndDate: null, orgGuid: null, blackListReleWiun: null, note: null };
  proxy.resetForm("formRef");
}

getList();
</script>
